.terraform_validate: &terraform_validate
  image: 
    name: hashicorp/terraform:0.14.0
    entrypoint: [""]
  variables:
    TF_VERSION: "0.14.0"
  before_script:
    # Configure terraform
    - cd ${TF_ROOT}
    - terraform init -backend-config="username=${TFSTATE_GITLAB_USER}" -backend-config="password=${TFSTATE_GITLAB_PASSWORD}"

    # Validate terraform files
    - terraform validate
  script: ls

.terraform_plan:
  image: 
    name: hashicorp/terraform:0.14.0
    entrypoint: [""]
  # $DOCKER_REGISTRY/$PROJECT_NAME/terraform-azure-cli:${COMMIT_TAG}
  # zenika/terraform-azure-cli:release-5.1_terraform-0.14.0-rc1_azcli-2.15.1
  variables:
    TF_PLAN_BINARY: tfplan.out
    TF_PLAN_JSON: tfplan.json
    TF_PLAN_CLEAN_JSON: tfplan_clean.json
  before_script:
    # Configure terraform
    - cd ${TF_ROOT}
    - terraform init -backend-config="username=${TFSTATE_GITLAB_USER}" -backend-config="password=${TFSTATE_GITLAB_PASSWORD}"

    # Plan changes
    - echo $TF_PLAN_BINARY
    - ls -alh  $TF_ROOT
    - terraform plan -var "azure_tenant_id=${AZURE_TENANT_ID}" -var "azure_subscription_id=${AZURE_SUBSCRIPTION_ID}" -var "azure_auth_client_id=${AZURE_CLIENT_ID}" -var "azure_auth_client_secret=${AZURE_CLIENT_SECRET}" -out="${TF_PLAN_BINARY}"
    
    # - shopt -s expand_aliases
    - apk add jq=1.6-r1 --no-cache
    - alias convert_report="jq -r '([.resource_changes[]?.change.actions?]|flatten)|{\"create\":(map(select(.==\"create\"))|length),\"update\":(map(select(.==\"update\"))|length),\"delete\":(map(select(.==\"delete\"))|length)}'"
    - terraform show --json $TF_PLAN_BINARY > $TF_PLAN_JSON
    - cat $TF_PLAN_JSON | convert_report > $TF_PLAN_CLEAN_JSON
  script: ls
  artifacts:
    reports:
      terraform: $TF_ROOT/$TF_PLAN_CLEAN_JSON

.terraform_apply:
  image: 
    name: hashicorp/terraform:0.14.0
    entrypoint: [""]
  # image: $DOCKER_REGISTRY/$PROJECT_NAME/terraform-azure-cli:${COMMIT_TAG}
  # zenika/terraform-azure-cli:release-5.1_terraform-0.14.0-rc1_azcli-2.15.1
  variables:
    TF_PLAN_BINARY: tfplan.out
  before_script:
    # Configure terraform
    - cd ${TF_ROOT}
    - terraform init -backend-config="username=${TFSTATE_GITLAB_USER}" -backend-config="password=${TFSTATE_GITLAB_PASSWORD}"

    # apply changes
    - terraform apply $TF_PLAN_BINARY

    # Install common utilities
    - apk add jq=1.6-r1 --no-cache
  script: ls